<?php
//
// Ant par Thibaut Maquet (http://www.pagasa.net)
// 
// Ce programme construit un fil RSS  partir de n'importe quelle page Web
// Placez simplement vos URL entre guillemets dans le fichier ant suivi d'un point-virgule et d'un mot cl optionnel.
//
// Vous pouvez ajouter une URL directement  distance en utilisant la commande suivante:
//
// http://votresite/ant.php?add=http://votreurl
//
// Ant doit pouvoir ecrire dans le repertoire courant
// Le programme effectue une rotation sur les URL  chaque chargement du fil.
// Les paramtrages divers se trouvent dans le fichier ant.conf
//
// 19-dec-2010: Une autre modification mineure
// 09-dec-2010: Modification mineure sur le dcodage
// 07-dec-2010: Version 1.3: Changement dans le paramtrage du fichier des URL pour grer au mieux les "URL  problme". La syntaxe est dsormais la suivante: 
//   "http://www.pagasa.net/?u.php=toto";votre mot cl
//
// 30-nov-2010: Version 1.2. Suppression de quelques fils RSS disparus. Amelioration de la gestion du fichier de conf et du parse RSS.
//
// 16-sept-2010: Version 1.1. Il est desormais possible d'utiliser un mot cl dans les titres des articles. 
//               Ceci se fait au moyen du fichier rss:
//               http://profile1;le mot cle a afficher
// 
// 14-sept-2010: Version 1.0

include("ant.conf");
function ant_mdie($txt) {
  ant_mlog($txt);
  die;
}

function ant_formatdate() {
  $date = sprintf("%4d-%02d-%02d %02d:%02d:%02d",date('Y'),date('n'), date('d') , date('H'),date('i'),date('s'));
  return $date;
}

function ant_mlog($txt) {
  $fd = @fopen("ant.log","a")  or die ("Impossible de creer le logfile");
  $a=getenv("REMOTE_ADDR");
  $date = sprintf("%4d-%02d-%02d %02d:%02d:%02d",date('Y'),date('n'), date('d') , date('H'),date('i'),date('s'));
  $t = ant_formatdate()." [$a] $txt\n";
  fwrite($fd,$t);
  fclose($fd);
}

function ant_remove($fn) {
  ant_mlog("Impossible d'accder  ".$fn);
  $fd2 = @fopen("ant.tmp","w");
  if(!$fd2)
    ant_mdie("Impossible de crer le fichier ant.tmp");
    
  $fd1 = @fopen("ant","r");
  if($fd1) {
    while(!feof($fd1)) {
      $li = fgets($fd1,10000);
      $mi = preg_replace("/\n/","",$li);
      if(!strstr($mi,$fn) && strlen($mi))
        fwrite($fd2,$mi."\n");
    }
  }
  else
    and_mdie("Impossible d'accder au fichier ant");
  ant_mlog($fn." a t supprim");
  fclose($fd1);
  fclose($fd2);
  @unlink("ant");
  @rename("ant.tmp","ant");
  die;
}

function ant_build() {
  $rss = "http://www.goarticles.com/cgi-bin/rss-search.cgi?&l=20&s=1&c=23&D1=subject&title=Hobbies,http://ezinearticles.com/rss/Recreation-and-Sports-Dancing.xml,http://www.articledirectory.com/rss.php?rss=167,http://www.articlemonkeys.com/rss.php?rss=117,http://www.articleco.com/rss/Hobbies/104,http://www.talkinmince.com/rss.php?rss=97,http://www.ehow.com/categoryrss.aspx?id=11,http://www.articlesbase.com/rss/categories/191,http://feeds.feedburner.com/articlealley/feeds_48,http://www.ideamarketers.com/categories/106.xml,http://www.isnare.com/rss/1/Entertainment.xml,http://www.a1articles.com/feeds_32.xml,http://www.article-buzz.com/rss/Hobbies/205,http://www.articlemaniac.com/rss/category/119.xml,http://www.goarticles.com/cgi-bin/rss-search.cgi?&l=20&s=1&c=78&D1=subject&title=Dating,http://ezinearticles.com/rss/Relationships-Dating.xml,http://www.articledirectory.com/rss.php?rss=321,http://www.articlemonkeys.com/rss.php?rss=129,http://www.articleco.com/rss/Dating/187,http://www.talkinmince.com/rss.php?rss=179,http://www.ehow.com/categoryrss.aspx?id=1,http://www.articlesbase.com/rss/categories/81,http://feeds.feedburner.com/articlealley/feeds_35,http://www.ideamarketers.com/categories/170.xml,http://www.isnare.com/rss/1/Dating.xml,http://www.a1articles.com/feeds_39.xml,http://www.goarticles.com/cgi-bin/rss-search.cgi?&l=20&s=1&c=7&D1=subject&title=Computers,http://ezinearticles.com/rss/Computers-and-Technology.xml,http://www.articledirectory.com/rss.php?rss=66,http://www.articlemonkeys.com/rss.php?rss=32,http://www.articleco.com/rss/Computers/10,http://www.talkinmince.com/rss.php?rss=31,http://www.ehow.com/categoryrss.aspx?id=5,http://www.articlesbase.com/rss/categories/144,http://feeds.feedburner.com/articlealley/feeds_11,http://www.ideamarketers.com/categories/151.xml,http://www.isnare.com/rss/1/Computers_and_Technology.xml,http://www.a1articles.com/feeds_11.xml,http://www.article-buzz.com/rss/Computers/69,http://www.articlemaniac.com/rss/category/30.xml,http://www.goarticles.com/cgi-bin/search.cgi?c=19&title=Finance,http://ezinearticles.com/rss/Finance.xml,http://www.articledirectory.com/rss.php?rss=120,http://www.articlemonkeys.com/rss.php?rss=226,http://www.articleco.com/rss/Finance/6,http://www.talkinmince.com/rss.php?rss=51,http://www.ehow.com/categoryrss.aspx?id=8,http://www.articlesbase.com/finance-articles/,http://feeds.feedburner.com/articlealley/feeds_19,http://www.isnare.com/rss/1/Finances.xml,http://www.a1articles.com/feeds_19.xml,http://www.article-buzz.com/rss/Finance/233,http://www.articlemaniac.com/rss/category/33.xml,http://www.goarticles.com/cgi-bin/search.cgi?c=28&title=Internet,http://ezinearticles.com/?cat=Internet-and-Businesses-Online,http://www.articledirectory.com/rss.php?rss=181,http://www.articlemonkeys.com/rss.php?rss=94,http://www.articleco.com/rss/Internet/354,http://www.talkinmince.com/rss.php?rss=106,http://www.ehow.com/categoryrss.aspx?id=20,http://www.articlesbase.com/rss/categories/93,http://feeds.feedburner.com/articlealley/feeds_81,http://www.isnare.com/rss/1/Internet.xml,http://www.a1articles.com/feeds_81.xml,http://www.article-buzz.com/rss/Internet-Business/72,http://www.articlemaniac.com/rss/category/37.xml,http://www.goarticles.com/cgi-bin/search.cgi?c=55&title=Sports,http://ezinearticles.com/rss/Recreation-and-Sports.xml,http://www.articledirectory.com/rss.php?rss=304,http://www.articlemonkeys.com/rss.php?rss=52,http://www.articleco.com/rss/Sports/11,http://www.talkinmince.com/rss.php?rss=148,http://www.ehow.com/categoryrss.aspx?id=4,http://www.articlesbase.com/rss/categories/64,http://feeds.feedburner.com/articlealley/feeds_32,http://www.isnare.com/rss/1/Sports.xml,http://www.a1articles.com/feeds_32.xml,http://www.article-buzz.com/rss/Sports-And-Recreation/81,http://www.articlemaniac.com/rss/category/40.xml";


  $fd = @fopen("ant","r");
  if($fd) {
    $li = fgets($fd,10000);
    $li = preg_replace("/\n/","",$li);
    fclose($fd);
  }
  else
    ant_mdie("Impossible d'accder au fichier ant");
  
  preg_match("/\"(.*?)\"/i", $li,$mt);

  if(empty($mt[1])) {
    $a = "Erreur de syntaxe dans le fichier ant - ";
    $a .= "Ligne $li - ";
    $a .= 'Usage: "http://lelien";le mot cl';  
    ant_mdie($a);
  }
  $fn  = $mt[1];
  if(strstr($fn,"&")) {
    ant_mlog("Caractre incompatible: ".$fn);
    ant_remove($fn);
  }

  $li = str_replace($mt[1],"",$li);
  $li = str_replace("\"\";","",$li);
  $li = str_replace("&","",$li);
  $mkw = $li;

  if(!strlen($mkw)) {
    if(strlen($fn)) {
      $fd =  @fopen($fn,"r");
      if($fd) {
        $li = "";
        while(!feof($fd))
          $li .= fgets($fd,10000);
        fclose($fd);
        $li = preg_replace("/\n/","",$li);
        preg_match("/<title>(.*?)<\/title>/i", $li,$mt);
        if(!empty($mt[1])) {
          $mtitle = htmlspecialchars_decode($mt[1]);
        }
        else
          $mtitle = "The profil of ".md5($fn);
      }
      else
       ant_remove($fn);
    }
    else {
     $a = "Ligne $li vide";
      ant_mdie($a);
    }
  }
  else
    $mtitle = $mkw;

  $t = explode(",",$rss);
  $mrss = $t[ mt_rand(0,count($t)-1) ];

  $fd =  @fopen($mrss,"r");
  if($fd) {
    $li = "";
    while(!feof($fd))
      $li .= fgets($fd,10000);
    fclose($fd);
    
    $li = preg_replace("/\n/","",$li);
    $j = preg_match_all("/<description>(.*?)<\/description>/i", $li,$mt);
     if(!empty($mt[0][$j-1])) {
      $mdesc = $mt[0][$j-1];
      $mdesc = preg_replace("/<!\[CDATA\[/","",$mdesc);
      $mdesc = preg_replace("/<description>/","",$mdesc);
      $mdesc = preg_replace("/<\/description>/","",$mdesc);
      $mdesc = preg_replace("/\]\]/","",$mdesc);
      $mdesc = preg_replace ("/([^A-Za-z0-9\'\.\+_\-,<>\/: ]+)/", "", $mdesc);

    }  
    else
      $mdesc = "The description of ".md5($rss);
  }
  else
    ant_mdie("Impossible de lire le flux rss ".$mrss);

//  $mh = '</description><content:encoded><![CDATA[<a href="http://www.google.fr">tutu</a>]]></content:encoded>';

//  $mdesc =  preg_replace("/<\/description>/i",$mh,$mdesc,1);

  $fd1 = @fopen("ant.tmp","w");
  if($fd1) {
    $li = "";
    $li .= "<item>\r\n";
    $li .= "<title>".$mtitle."</title>\r\n";
    $li .= "<description>".$mdesc."</description>\r\n";
    $li .= "<pubDate>".strftime("%a, %d %b %Y %H:%M:%S +0100",time())."</pubDate>\r\n";
    $li .= "<link>".$fn."</link>\r\n";
    $li .= "<guid>".$fn."</guid>\r\n";
    $li .= "</item>\n";
    fwrite($fd1,$li);
    $fd2 = @fopen("ant.rss","r");
    if($fd2) {
      $li = "";
      while (!feof ($fd2))
        $li .= fgets($fd2,10000);
      fwrite($fd1,$li);
      fclose($fd2);
    }
    fclose($fd1);
    @unlink("ant.rss");
    @rename("ant.tmp","ant.rss");
  }
  else
    ant_mdie("Impossible de crer le fichier ant.tmp");

}

function ant_add($madd) {
  $fd1 = @fopen("ant.tmp","w");
  if($fd1) {
    fwrite($fd1,$madd."\r\n");
    $fd2 = @fopen("ant","r");
    if($fd2) {
      $li = "";
      while (!feof ($fd2))
        $li .= fgets($fd2,10000);
      fwrite($fd1,$li);
      fclose($fd2);
    }
    else
      ant_mdie("Impossible de lire le fichier ant");
    fclose($fd1);
  }
  else
    ant_mdie("Impossible de crer le fichier ant.tmp");
  @unlink("ant");
  @rename("ant.tmp","ant");

  echo $madd."->OK";
}

function ant_rotate() {
  global $mmax_rss;

  $fd1 = @fopen("ant","r");
  if($fd1) {
    $a1 = fgets($fd1, 100000);
    $fd2 =  @fopen("ant.tmp","w");
    if($fd2) {
      $li = "";
      while (!feof ($fd1))
        $li .= fgets($fd1,10000);
      fwrite($fd2,$li);
      $a1 =  preg_replace("/\n/","",$a1);
      if(strlen($a1))
        fwrite($fd2,$a1."\n");
      fclose($fd2);
      fclose($fd1);
      @unlink("ant");
      @rename("ant.tmp","ant");
    }
    else
      ant_mdie("Impossible de creer le fichier ant.tmp");
  }
  else
    ant_mdie("Impossible d'ouvrir le fichier ant");

  $fd1 = @fopen("ant.tmp","w");
  if($fd1) {
    $fd2 = @fopen("ant.rss","r");
    if($fd2) {
      $li ="";
      while (!feof ($fd2))
        $li .= fgets($fd2,10000);
      fclose($fd2);
      $mi = preg_replace("/\r\n/","<truc>",$li);
      $j = preg_match_all("/<item>(.*?)<\/item>/i",  $mi,$mt);
      $i = 0;
      $n = $mmax_rss;
      while($i < $j && $n) {
        $mi = preg_replace("/<truc>/","\r\n",$mt[0][$i]);
        fwrite($fd1,$mi);
        $n--;
        $i++;
      }
      @unlink("ant.rss");
      @rename("ant.tmp","ant.rss");
    }
    else
      ant_mdie("Impossible de lire le fichier ant.rss");
    fclose($fd1);
  }
  else
    ant_mdie("Impossible de creer le fichier ant.tmp");

}

function ant_out() {
  global $mbigtitle;
  global $mencod;
  global $mlang;
  global $mdesc;


  $li = "";
  $li .= '<?xml version="1.0" encoding="'.$mencod.'" ?>'."\r\n";
  $li .= '<rss version="2.0"'."\r\n";
  $li .= 'xmlns:content="http://purl.org/rss/1.0/modules/content/"'."\r\n";
  $li .= 'xmlns:wfw="http://wellformedweb.org/CommentAPI/"'."\r\n";
  $li .= 'xmlns:dc="http://purl.org/dc/elements/1.1/"'."\r\n";
  $li .= 'xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"'."\r\n";
  $li .= 'xmlns:slash="http://purl.org/rss/1.0/modules/slash/"'."\r\n";
  $li .= 'xmlns:atom="http://www.w3.org/2005/Atom"'."\r\n";
  $li .= ">\r\n";

  $li .= "<channel>\r\n";
  $li .= "<title>".$mbigtitle."</title>\r\n";
  $li .= '<atom:link href="http://'.getenv("HTTP_HOST"). $_SERVER['PHP_SELF'].'" rel="self" type="application/rss+xml" />'."\r\n";

  $li .= "<link>http://".getenv("HTTP_HOST")."</link>\r\n";
  $li .= "<description>".$mdesc."</description>\r\n";
  $li .= "<lastBuildDate>".strftime("%a, %d %b %Y %H:%M:%S +0100",time())."</lastBuildDate>\r\n";
  $li .= "<language>".$mlang."</language>\r\n";
  $li .= "<sy:updatePeriod>hourly</sy:updatePeriod>\r\n";
  $li .= "<sy:updateFrequency>1</sy:updateFrequency>\r\n";
  $li .= "<generator>http://www.pagasa.net</generator>\r\n";

  $fd = @fopen("ant.rss","r");
  if($fd) {
    while (!feof ($fd))
      $li .= fgets($fd,10000);
    fclose($fd);
  }
  else
    ant_mdie("Impossible de lire le fichier ant.rss");

  $li .= " </channel>\r\n </rss>\r\n";

  echo $li;

}

function ant_main() {
  ant_build();
  ant_rotate();
  ant_out();
}
$madd = (isset($_GET['add'])) ? $_GET['add'] : "";
if(!empty($madd)) 
  ant_add($madd);
else
  ant_main();  
?>
